package com.vendor.burn.log;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.burn.model.cmdline.CmdLineParam;
import com.vendor.burn.utilitily.JarUtility;
import com.vendor.burn.utilitily.ToolUtils;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.HashMap;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.osgi.service.datalocation.Location;
import org.eclipse.swt.widgets.Display;

public class Log {
  public static final long MAX_SIZE = 268435456L;
  
  public static final String NEW_LINE = "\n";
  
  private static final HashMap<Integer, String> ERROR_INFO_MAP = (HashMap<Integer, String>)new Object();
  
  private static IPath getCachePath() {
    String file = "";
    if (ToolUtils.isCmdLine()) {
      String logFileParentPath = CmdLineParam.getLogFileParentPath();
      if (logFileParentPath == null)
        logFileParentPath = JarUtility.getJarDir(); 
      if (logFileParentPath != null)
        if (!logFileParentPath.endsWith(File.separator)) {
          file = logFileParentPath.concat(File.separator);
        } else {
          file = logFileParentPath;
        }  
    } else {
      Location installLocation = Platform.getInstallLocation();
      file = installLocation.getURL().getFile();
    } 
    return (IPath)new Path(file);
  }
  
  public static IPath getLogFileDir() {
    return getCachePath().append(File.separator).append("logs");
  }
  
  public static IPath getLogFile() {
    return getLogFileDir().append(File.separator).append("BurnTool").addFileExtension("log");
  }
  
  public static FileOutputStream getLog() throws FileNotFoundException {
    File file = getLogFile().toFile();
    if (file.length() > 268435456L)
      return new FileOutputStream(file, false); 
    return new FileOutputStream(file, true);
  }
  
  public static void print(String message) {
    System.out.print(message);
  }
  
  public static void println(String message) {
    print(message + "\n");
  }
  
  public static void info(String message) {
    print(message);
  }
  
  public static void infoln(String message) {
    print(message + "\n");
  }
  
  public static void error(String message) {
    System.out.print(message);
  }
  
  public static void errorln(String message) {
    System.out.println("Error: " + message);
  }
  
  public static void received(String received) {
    System.out.print(received);
  }
  
  public static void receivedln(String received) {
    System.out.println(received);
  }
  
  public static void warn(String warning) {
    print(warning);
  }
  
  public static void warningln(String warning) {
    print(warning + "\n");
  }
  
  public static void returnError(String error) {
    errorln(error);
  }
  
  public static void printErrorInfo(int errorCode) {
    Display.getDefault().syncExec((Runnable)new Object(errorCode));
  }
}
